<?php
/* -----------------------------------------------------------------------------
  Plugin     : Translator
  Author     : Grum
    email    : grum@piwigo.org
    website  : http://photos.grum.dnsalias.com
    PWG user : http://forum.phpwebgallery.net/profile.php?id=3706

    << May the Little SpaceFrog be with you ! >>
  ------------------------------------------------------------------------------
  See main.inc.php for release information

  Translator_root : root classe for plugin

  --------------------------------------------------------------------------- */

  if (!defined('PHPWG_ROOT_PATH')) { die('Hacking attempt!'); }

  include_once(PHPWG_ROOT_PATH.'admin/include/plugins.class.php');
  include_once(PHPWG_PLUGINS_PATH.'grum_plugins_classes-2/common_plugin.class.inc.php');
  include_once(PHPWG_PLUGINS_PATH.'grum_plugins_classes-2/ajax.class.inc.php');
  include_once(PHPWG_PLUGINS_PATH.'grum_plugins_classes-2/genericjs.class.inc.php');

  /* 
      generic class for translator
        initialize plugin name and tables names list
  */
  class Translator_root extends common_plugin
  {
    protected $ajax;
    protected $backup_file_name;
    protected $translator_nfo;

    function Translator_root($prefixeTable, $filelocation)
    {
      parent::__construct($prefixeTable, $filelocation);
      $this->plugin_name='Translator';
      $this->plugin_name_files='translator';
      $this->section_name=$this->plugin_name;

      $this->set_tables_list(array('files', 'keys', 'langs', 'langs_codes', 'users', 'users_langs', 'countries_codes'));

      $this->statuslist=array(
        'none' => 'g001_filternone',
        'ok' => 'g001_validated',
        'valide_it' => 'g001_to_validate',
        'not_translated' => 'g001_to_translate',
        'deleted' => 'g001_deleted'
      );
      $this->ajax = new Ajax();

      $this->backup_file_name = dirname($this->filelocation)."/".$this->plugin_name."_database_backup.sql";
      $this->translator_nfo=array('istranslator' => false);
    }


    public function init_events()
    {
      add_event_handler('blockmanager_register_blocks', array(&$this, 'register_blocks') );
      add_event_handler('user_init', array(&$this, 'init_user_nfo') );
    }

    public function register_blocks( $menu_ref_arr )
    {
      $menu = & $menu_ref_arr[0];
      if ($menu->get_id() != 'menubar')
        return;
      $menu->register_block( new RegisteredBlock( 'mbTranslator_register', 'Translation', $this->plugin_name));
    }

    public function init_user_nfo($user)
    {
      $tmp=$this->get_translators_info($user['id']);
      if($tmp===false)
      {
        $this->translator_nfo['istranslator'] = false;
      }
      else
      {
        $this->translator_nfo=$tmp;
        $this->translator_nfo['istranslator'] = true;
      }
    }

    /*
      initialize default values 
    */
    function init_config()
    {
      //global $user;
      $this->my_config=array(
        //if autoscan set to 'y', everytime user acceed "status page", directories
        //are a scanned to see if there is new files, modified files, or deleted files
        'autoscan' => 'y',
        // 
        'mainlang' => 'en_UK',
        //bargraph's color for translate translation (tt)
        'color_bars1' => 'ff0000',
        //bargraph's color for to validate translation (tv)
        'color_bars2' => 'ff9000',
        //bargraph's color for to validated translation (to)
        'color_bars3' => '00ff00',
        //bargraph's color for to validated translation (td)
        'color_bars4' => 'ff00ff',
        //bargraph's color for undefined translation state
        'color_bars5' => '555555',
        //color for row overrided by mouse
        'mouse_over_color' => '303030',
        //width (in px) for graph's bars
        'bars_width' => '115',
        //number of items displayed
        'number_of_items' => 25,
        //default status filter applyed ('none', 'ok', 'valide_it', 'not_translated')
        'default_status_filter' => 'none',
        //additional languages (base assumed : fr_FR)
        'additional_langs' => 'fr_FR',
        //maximum of items exported by a call to export_phase1
        'export_maximum_items' => 1000,
        //width (in px) for progress bar
        'progress_bar_width' => 400,
        //translator_mode (array of user id)
        'translator_mode' => array(),
        //allow user to register in public part of site
        'translator_canregister' => 'n',
        //if user can register, validate 
        'translator_need_admin_to_be_registered' => 'y',
        //when user ask to be a translator, send mail to admin
        'mail_to_admin' => 'y'
      );
    }





    /* ---------------------------------------------------------------------------
      base functions
    --------------------------------------------------------------------------- */

    /*
      this function scan directories & sub-directories to find *.lang.php files
      returns an array of filenames

      if $dir is specified, begin scan at $dir directory, else begin scan at PWG root path
    */
    function search_languages_files($dir="")
    {
      $returned=array();
      if($dir=="")
      {
        $dir = PHPWG_ROOT_PATH;
      }
      if(substr($dir,-1,1)=="/")
      {
        $dir=substr($dir,0,strlen($dir)-1);
      }
      if ($opendir = opendir($dir))
      {
        while ($file = readdir($opendir))
        {
          if ($file != '.'
              and $file != '..'
              and is_dir($dir.'/'.$file)
              and $file != 'CVS'
              and $file != '.svn')
          {
            $returned=array_merge($returned, $this->search_languages_files($dir.'/'.$file));
          }
          elseif((strpos(strtolower($file), ".lang.php")!==false)&&
                  (get_extension($file)=='php')&&
                  (strtolower($file)!='local.lang.php')
          )
          {
            array_push($returned, $dir.'/'.$file);
          }
        }
      }    
      return($returned);
    }

    /*
      analyze a ".lang.php" filename and returns
        - filename
        - language
        - file type (pwg or plugins)
        - last date/time of modification (unix timestamp)
        returned as an array
    */
    function analyze_filename($filename)
    {
      $plugin = new plugins();

      $file=basename($filename);
      $language=basename(dirname($filename));
      if(strpos($filename, "/plugins/")!==false)
      {
        $type='plugin';
        $tmp=explode('/plugins/', $filename);
        $tmp=explode('/', $tmp[1]);
        $name=$tmp[0];
        $plugins=$plugin->get_fs_plugins();
        if(isset($plugins[$name]))
        {
          $version=$plugins[$name]['version'];
        }
        else
        {
          $version='n/a';
        }
      }
      else
      {
        $type='piwigo';
        $name='core';
        $version=PHPWG_VERSION;
      }
      clearstatcache();
      return(array(
        'filename' => $filename,
        'file' => $file,
        'lang' => $language,
        'type' => $type,
        'modified' => filemtime($filename),
        'name' => $name,
        'version' => $version
                  ));
    }

    /* ---------------------------------------------------------------------------
      management functions
    --------------------------------------------------------------------------- */

    function insert_lang_key($id, $user_id, $key, $val, &$errors, &$nbelem)
    {
      if(is_array($val))
      {
        while(list($ikey, $ival) = each($val))
        {
//echo "Array:val:$val::$ival<br>";
          $this->insert_lang_key($id, $user_id, $key." [#".$ikey."]", $ival, $errors, $nbelem);
        }
      }
      else
      {
//echo "key:$key // val:$val<br>";
        $sql="INSERT INTO ".$this->tables['keys']." VALUES (
          '".$key."',
          '".$id."',
          '1',
          '".date('Y-m-d H:i:s')."',
          '".$user_id."',
          'valide_it',
          '".addslashes($val)."',
          '0',
          '0000-00-00 00:00:00',
          '".$this->calculate_uniquekey($key, $id)."'
        )";
        if(!pwg_query($sql))
        {
          array_push($errors, array('T',$key, $val));
        }
        else
        {
          $nbelem++;
        }
      }

    }

    /*
      return info about a lang referenced into langs table
        search by 'code' (eg. en_UK.iso-8859-1)
    */
    function get_language_info_by_code($code)
    {
      $returned=array();
      $sql="SELECT t1.*, count(t0.id) as nbfile
            FROM ".$this->tables['langs']." t1
              LEFT OUTER JOIN ".$this->tables['files']." t0
              ON t0.language = t1.code
            WHERE t1.code = '".$code."'
            GROUP BY t1.code
            ";

      $result=pwg_query($sql);
      if($result)
      {
        if(mysql_num_rows($result)>0) { $returned=mysql_fetch_assoc($result); }
      }
      return($returned);
    }


    /*
      future release : call this function during the install process ?

      load a lang files into database
        $lang : new lang
        $files_list : list of analyzed files
        $user_id : user who initiate this process
    */
    function load_lang_files($language='', $files_list, $user_id)
    {
      $errors=array();

      $yesno=array(true=>'y', false=>'n');
      foreach($files_list as $file)
      {
//echo "fichier:".$file['filename'].":".file_exists($file['filename'])."<br>";
        if(($file['lang']==$language)||($language==''))
        {
//echo "langue:".$file['lang']."<br>";
          $sql="INSERT INTO ".$this->tables['files']." VALUES (
            '',
            '".$file['type']."',
            '".basename($file['filename'])."',
            '".$file['lang']."',
            '".$file['version']."',
            '".$file['name']."',
            '".$file['filename']."',
            '0',
            '0',
            '0',
            '0',
            '".date('Y-m-d H:i:s', $file['modified'])."',
            '0'
          )";
          if(pwg_query($sql))
          {
//echo "insert ok<br>";
            $id=mysql_insert_id();
            $nbelem=0;
            unset($lang);
            unset($lang_info);
            //include $lang array
            include($file['filename']);
            //$lang=$this->load_lang_file($file['filename']);
//echo "nb items:".count($lang)."<br>";
            foreach($lang as $key => $val)
            {
              $this->insert_lang_key($id, $user_id, $key, $val, $errors, $nbelem);
            }
            if(isset($lang_info))
            {
              $db_lang=$this->get_language_info_by_code($file['lang']);
              if(count($db_lang)==0)
              {
                $tmp=explode('.', $file['lang']);
                $tmp=explode('_', $tmp[0]);

                $sql="INSERT INTO ".$this->tables['langs']." VALUES (
                  '".$lang_info['code']."',
                  '".$tmp[1]."',
                  '".$lang_info['direction']."',
                  '".$lang_info['language_name']."',
                  '".$lang_info['country']."',
                  '".$yesno[$lang_info['zero_plural']]."',
                  '".$file['lang']."'
                )";
                $result=pwg_query($sql);
//echo "lang_info sql:".$sql."</br>";
              }
//echo "lang_infos:".print_r($lang_info,true)."<br>";
            }

            $sql="UPDATE ".$this->tables['files']."
                  SET nb_elem = '".$nbelem."',
                      nb_to_validate = '".$nbelem."'
                  WHERE id = '".$id."'";
            pwg_query($sql);
          }
          else
          {
            array_push($errors, array('F',$file));
          }
        }
      }

      return($errors);
    }

    function calculate_uniquekey($key, $file)
    {
      return(md5($file.'-'.$key));
    }

    

    /*
      returns translators list from translators table
    */
    function get_translators_list($user_id="")
    {
      $returned=array();
      $sql="SELECT pu.username as name, pui.adviser, ptu.*, ptul.lang as spoken_language, floor((datediff(now(), ptu.birthdate))/365) as age
  FROM ".USERS_TABLE." pu,
       ".USER_INFOS_TABLE." pui,
       ".$this->tables['users']." ptu LEFT OUTER JOIN
       ".$this->tables['users_langs']." ptul
       ON ptu.id = ptul.id 
  WHERE ptu.id = pu.id 
    AND pu.id = pui.user_id ";
      if($user_id!="")
      {
        $sql.="AND ptu.id = ".$user_id." ";
      }
      $sql.="ORDER BY ptu.country, pu.username, ptul.lang ";

      $result=pwg_query($sql);
      if($result)
      {
        $user_id = -1;
        while($row=mysql_fetch_assoc($result))
        {
          if($user_id != $row['id'])
          {
            $user_id = $row['id'];
            $returned[$user_id]=$row;
          }
          else
          {
            $returned[$user_id]['spoken_language'].=",".$row['spoken_language'];
          }
        }
      }
      return($returned);
    }

    /*
      if user is a translator, return info about it
    */
    function get_translator_info()
    {
//echo "translator_info ".get_class($this)." ".print_r($this->translator_nfo)."<br>";
      return($this->translator_nfo);
    }


    /*
      return info about a translator referenced into translators table
    */
    function get_translators_info($user_id)
    {
      $returned=$this->get_translators_list($user_id);
      if(count($returned)>0)
      {
        $returned=$returned[$user_id];
      }
      else
      {
        $returned=false;
      }
      return($returned);
    }

    /*
      insert a new lang into 'langs' table
        $nfo is an array
    */
    function add_translator($nfo, $validate=true)
    {
      global $page;
      if(is_adviser())
      {
        // an adviser or a translator can't add a new translator
        $this->adviser_abort();
        return(false);
      }
  
      $sql="SELECT status FROM ".USER_INFOS_TABLE." WHERE user_id = '".$nfo['id']."'";
      $result=pwg_query($sql);
      if($result)
      {
        $row=mysql_fetch_row($result);
        if(($row[0]=='guest')||($row[0]=='webmaster'))
        {
          $this->display_result(l10n("g001_not_allowed"), false);
          return(false);
        }
      }
      else
      {
        $this->display_result(l10n("g001_not_allowed"), false);
        return(false);
      }


      $sql="INSERT INTO ".$this->tables['users']." VALUES (
      '".$nfo['id']."',
      '".$nfo['country']."',
      '".$nfo['town']."',
      '".$nfo['native_language']."',
      '".$nfo['sex']."',
      '".$nfo['birthdate']."',
      '".$nfo['comment']."', 
      '".$nfo['display_spoken_lang']."', 
      '".$nfo['default_displayed_language']."'
      )";
      $result=pwg_query($sql);
      if($result)
      {
        if($nfo['spoken_language']!='')
        {
          $tmp=explode(",", $nfo['spoken_language']);
          foreach($tmp as $key => $val)
          {
            $sql="INSERT INTO ".$this->tables['users_langs']." VALUES (
              '".$nfo['id']."', '".$val."'
            )";
            $result=pwg_query($sql);
          }
        }
        if($validate)
        {
          return($this->validate_user($nfo['id']));             
        }
        else
        {
          return(true);
        }
      }
      return(false);
    }

    /*
      return true if user is a translator, otherwise false
    */
    public function is_translator()
    {   
      /*global $user;

      $sql="SELECT id FROM ".$this->tables['users']."
          WHERE id = '".$user['id']."'";
      $result=pwg_query($sql);
      if($result)
      {
        if(mysql_num_rows($result)>0) 
        {
          return(true);
        }
      }
      return(false);*/
      return($this->translator_nfo['istranslator']);
    }

    /*
      made user admin/adviser
    */
    public function validate_user($user_id)
    {
      $sql="UPDATE ".USER_INFOS_TABLE." SET adviser = 'true', status = 'admin' WHERE user_id = '".$user_id."'";
      $result=pwg_query($sql);
      if($result)
      {
        return(true);
      }
      return(false);
    }
    

    /* ---------------------------------------------------------------------------
      unclassed functions
    --------------------------------------------------------------------------- */


    /*
      manage adviser profile
        return true if user is adviser
    */
    function adviser_abort()
    {
      if(is_adviser())
      {
        $this->display_result(l10n("g001_translator_adviser_not_allowed"), false);
        return(true);
      }
      return(false);
    }



  } //class

?>
